%% Part 1: Basics
% The Very Essential Matlab Commands:
addpath(genpath(pwd));
which test
doc addMinusTwoVec
whos
clear all;
close all;
clearvars -except a
%  ***** google is always a great resource *****

%% Part 2: Matrices and such

% doc elfun
% doc datafun
% creating vectors
a = 1:10;
b = 1:2:10;
% creating matrices
A = [1 3 5;2 4 6];
D = [];
A = zeros(3, 5);
B = ones(2, 3);
D = diag(1:4);

% matrix computations
% Element-wise Calculation Functions
a = [8 6 7 5 3 0 9]/10
abs(a)
sin(a) % radians!
cos(a) % radians!

floor(a) % nearest integer <= each element
ceil(a) % nearest integer >= each element

% Vector Calculation Functions
a = [8 6 7 5 3 0 9]          % A row vector
sum(a)                       % Sum of vector elements

% Functions can also apply to each COLUMN of a matrix
A = [1 2 3 4;
    10 20 30 40]
sum(A)
mean(A)

% What if we want to operate on each ROW?
sum(A, 2)
mean(A, 2)

% transpose
C = C';
% concatenation
D = [C;B];
D = D(:);
% reshaping matrices
D = reshape(D, [2, 6]);
% changing values in matrices
D(1, 4) = 10;
D(:, 1) = [12;45];
D(:, 6) = [];
% % matrix indexing
% size(D);
% [ind_row, ind_col] = ind2sub(size(D), 5);
% ind = sub2ind(size(D), ind_row, ind_col);

%% Part 3 Flow of control
% similar to C or other programming languages
a = 3;
% if statements
if (a==3)
    fprintf('A==3\n');
else
    fprintf('A~=3\n');
end

% loop statements
a = 10:-1:1;
for i = 1:length(a)
   fprintf('%d\n', a(i)); 
end
a = 1;b = 0;
while(a || b)
    fprintf('A || B is true\n');
    a = 0;
    b = 0;
end

%% Part 5: Plotting
X = 0:.01:pi;  y = sin(X)                        % generate some synthetic data
f1 = figure;                                     % create a blank figure
p1 = plot(X,y,'.');                              % plot X vs y
X1 = X;

p2 = plot(X,y,'o','MarkerEdgeColor','k',...      % plot larger red circles with black edges
                  'MarkerFaceColor','r',...
                  'MarkerSize',8);
% parameters to set when plotting              
axis([-1,4,-1,1]);
xlabel('x'); ylabel('y');title('this is the title');
